; from "The Last Memory" manual
;
; halts on error
;

	org	0000h

first	equ	0100h
last	equ	0f0h		; ending 256 byte page

start:	xra	a
	mov	b, a
loop:	lxi	h, first
	mov	c, b
store:	mov	m, c		; write the byte #
	inx	h
	inr	c
	jnz	skip
	inr	c
skip:	mov	a, h
	cpi	last		; done writing?
	jnz	store		; no
	mov	a, b
	lxi	h, first	; ready to check the data
read:	mov	e, m
	cmp	e
	jnz	error
	inx	h
	inr	a
	jnz	zip
	inr	a
zip:	mov	c, a
	mov	a, h
	cpi	last		; done checking?
	mov	a, c
	jnz	read		; no
	inr	b
	jmp	loop
error:	shld	lowa
	sta	dwr
	mov	a, e
	sta	drd
	halt

lowa:	ds	1
hia:	ds	1
dwr:	ds	1
drd:	ds	1

end
